//+------------------------------------------------------------------+
//|                                    Upper_Consolidation_Lines.mq4 |
//|                                                     Piotr Kalisz |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Piotr Kalisz"
#property link      ""

#import  "PKlibrary.ex4"
   int Cross1(double dbLine1, double dbLine2);
   int Cross2(double dbLine1, double dbLine2);
#import

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 LightGray

extern double     HMA1Period=89;
extern double     HMA2Period=144;
extern int        HMA1Price=0;
extern int        HMA2Price=0;
extern int        HMA1Type=0;
extern int        HMA2Type=0;
extern double     Consolidation=44;

//---- buffers
double   UPL[],MA1, MA2,ConsPrice,tempUPL[];
int      i, time,n;
bool     ConsEntry, ConsExit, ConsCond;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexBuffer(0,UPL);
   SetIndexEmptyValue(0,0.0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
 //----
   time=Bars;
   ArrayResize(tempUPL, time);
   for(i=time;i>0;i--){
      MA1=NormalizeDouble(iCustom(NULL,0,"Moving Averages",HMA1Period,HMA1Price,HMA1Type,0,i),4);
      MA2=NormalizeDouble(iCustom(NULL,0,"Moving Averages",HMA2Period,HMA2Price,HMA2Type,0,i),4);
      ConsEntry=Cross1(MA1,MA2);
      if(ConsEntry!=0){
         ConsPrice=iClose(NULL,0,i);
         ConsCond=1;
         ConsExit = 0;
         tempUPL[i]=ConsPrice+(Consolidation/2)*Point;
         }
      if(ConsCond==1){   
         if(Cross2(UPL[i],iClose(NULL,0,i))!=0){
            ConsExit=1;
            ConsCond=0;
            }            
         }   
       if(ConsCond==1 || ConsExit==1){
         tempUPL[i]=ConsPrice+(Consolidation/2)*Point;
         }
       if(ConsCond!=0 || ConsExit!=0){   
         UPL[i]=tempUPL[i];
         } else { 
            UPL[i]=NULL;
            }
      ConsEntry=0;
      ConsExit=0;
      
      }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+